Index: kernel/test/mm/falloc2.c
===================================================================
--- kernel/test/mm/falloc2.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ kernel/test/mm/falloc2.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -40,5 +40,5 @@
 #include <arch.h>
 
-#define MAX_FRAMES  256U
+#define MAX_FRAMES  256
 #define MAX_ORDER   8
 
@@ -51,11 +51,11 @@
 static void falloc(void *arg)
 {
+	int order, run, allocated, i;
 	uint8_t val = THREAD->tid % THREADS;
+	size_t k;
 	
-	void **frames = (void **)
-	    malloc(MAX_FRAMES * sizeof(void *), FRAME_ATOMIC);
+	void **frames =  (void **) malloc(MAX_FRAMES * sizeof(void *), FRAME_ATOMIC);
 	if (frames == NULL) {
-		TPRINTF("Thread #%" PRIu64 " (cpu%u): "
-		    "Unable to allocate frames\n", THREAD->tid, CPU->id);
+		TPRINTF("Thread #%" PRIu64 " (cpu%u): Unable to allocate frames\n", THREAD->tid, CPU->id);
 		atomic_inc(&thread_fail);
 		atomic_dec(&thread_count);
@@ -65,14 +65,11 @@
 	thread_detach(THREAD);
 	
-	for (unsigned int run = 0; run < THREAD_RUNS; run++) {
-		for (unsigned int order = 0; order <= MAX_ORDER; order++) {
-			TPRINTF("Thread #%" PRIu64 " (cpu%u): "
-			    "Allocating %u frames blocks ... \n", THREAD->tid,
-			    CPU->id, 1 << order);
+	for (run = 0; run < THREAD_RUNS; run++) {
+		for (order = 0; order <= MAX_ORDER; order++) {
+			TPRINTF("Thread #%" PRIu64 " (cpu%u): Allocating %d frames blocks ... \n", THREAD->tid, CPU->id, 1 << order);
 			
-			unsigned int allocated = 0;
-			for (unsigned int i = 0; i < (MAX_FRAMES >> order); i++) {
-				frames[allocated] =
-				    frame_alloc(order, FRAME_ATOMIC | FRAME_KA);
+			allocated = 0;
+			for (i = 0; i < (MAX_FRAMES >> order); i++) {
+				frames[allocated] = frame_alloc(order, FRAME_ATOMIC | FRAME_KA);
 				if (frames[allocated]) {
 					memsetb(frames[allocated], FRAME_SIZE << order, val);
@@ -82,18 +79,12 @@
 			}
 			
-			TPRINTF("Thread #%" PRIu64 " (cpu%u): "
-			    "%u blocks allocated.\n", THREAD->tid, CPU->id,
-			    allocated);
-			TPRINTF("Thread #%" PRIu64 " (cpu%u): "
-			    "Deallocating ... \n", THREAD->tid, CPU->id);
+			TPRINTF("Thread #%" PRIu64 " (cpu%u): %d blocks allocated.\n", THREAD->tid, CPU->id, allocated);
+			TPRINTF("Thread #%" PRIu64 " (cpu%u): Deallocating ... \n", THREAD->tid, CPU->id);
 			
-			for (unsigned int i = 0; i < allocated; i++) {
-				for (size_t k = 0; k <= (((size_t) FRAME_SIZE << order) - 1);
-				    k++) {
+			for (i = 0; i < allocated; i++) {
+				for (k = 0; k <= (((size_t) FRAME_SIZE << order) - 1); k++) {
 					if (((uint8_t *) frames[i])[k] != val) {
-						TPRINTF("Thread #%" PRIu64 " (cpu%u): "
-						    "Unexpected data (%c) in block %p offset %zu\n",
-						    THREAD->tid, CPU->id, ((char *) frames[i])[k],
-						    frames[i], k);
+						TPRINTF("Thread #%" PRIu64 " (cpu%u): Unexpected data (%c) in block %p offset %zu\n",
+						    THREAD->tid, CPU->id, ((char *) frames[i])[k], frames[i], k);
 						atomic_inc(&thread_fail);
 						goto cleanup;
@@ -103,6 +94,5 @@
 			}
 			
-			TPRINTF("Thread #%" PRIu64 " (cpu%u): "
-			    "Finished run.\n", THREAD->tid, CPU->id);
+			TPRINTF("Thread #%" PRIu64 " (cpu%u): Finished run.\n", THREAD->tid, CPU->id);
 		}
 	}
@@ -111,6 +101,5 @@
 	free(frames);
 	
-	TPRINTF("Thread #%" PRIu64 " (cpu%u): Exiting\n",
-	    THREAD->tid, CPU->id);
+	TPRINTF("Thread #%" PRIu64 " (cpu%u): Exiting\n", THREAD->tid, CPU->id);
 	atomic_dec(&thread_count);
 }
@@ -118,10 +107,11 @@
 const char *test_falloc2(void)
 {
+	unsigned int i;
+	
 	atomic_set(&thread_count, THREADS);
 	atomic_set(&thread_fail, 0);
 	
-	for (unsigned int i = 0; i < THREADS; i++) {
-		thread_t *thrd = thread_create(falloc, NULL, TASK,
-		    THREAD_FLAG_NONE, "falloc2");
+	for (i = 0; i < THREADS; i++) {
+		thread_t * thrd = thread_create(falloc, NULL, TASK, 0, "falloc", false);
 		if (!thrd) {
 			TPRINTF("Could not create thread %u\n", i);
@@ -132,6 +122,5 @@
 	
 	while (atomic_get(&thread_count) > 0) {
-		TPRINTF("Threads left: %" PRIua "\n",
-		    atomic_get(&thread_count));
+		TPRINTF("Threads left: %" PRIua "\n", atomic_get(&thread_count));
 		thread_sleep(1);
 	}
Index: kernel/test/mm/slab1.c
===================================================================
--- kernel/test/mm/slab1.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ kernel/test/mm/slab1.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -155,6 +155,6 @@
 	
 	semaphore_initialize(&thr_sem, 0);
-	for (i = 0; i < THREADS; i++) {
-		if (!(t = thread_create(slabtest, (void *) (sysarg_t) i, TASK, THREAD_FLAG_NONE, "slabtest"))) {
+	for (i = 0; i < THREADS; i++) {  
+		if (!(t = thread_create(slabtest, (void *) (sysarg_t) i, TASK, 0, "slabtest", false))) {
 			TPRINTF("Could not create thread %d\n", i);
 		} else
Index: kernel/test/mm/slab2.c
===================================================================
--- kernel/test/mm/slab2.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ kernel/test/mm/slab2.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -52,6 +52,6 @@
 	void *olddata1 = NULL, *olddata2 = NULL;
 	
-	cache1 = slab_cache_create("test_cache1", ITEM_SIZE, 0, NULL, NULL, 0);
-	cache2 = slab_cache_create("test_cache2", ITEM_SIZE, 0, NULL, NULL, 0);
+	cache1 = slab_cache_create("cache1_tst", ITEM_SIZE, 0, NULL, NULL, 0);
+	cache2 = slab_cache_create("cache2_tst", ITEM_SIZE, 0, NULL, NULL, 0);
 	
 	TPRINTF("Allocating...");
@@ -210,6 +210,6 @@
 	thr_cache = slab_cache_create("thread_cache", size, 0, NULL, NULL, 0);
 	semaphore_initialize(&thr_sem,0);
-	for (i = 0; i < THREADS; i++) {
-		if (!(t = thread_create(slabtest, NULL, TASK, THREAD_FLAG_NONE, "slabtest"))) {
+	for (i = 0; i < THREADS; i++) {  
+		if (!(t = thread_create(slabtest, NULL, TASK, 0, "slabtest", false))) {
 			TPRINTF("Could not create thread %d\n", i);
 		} else
Index: kernel/test/synch/semaphore1.c
===================================================================
--- kernel/test/synch/semaphore1.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ kernel/test/synch/semaphore1.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -93,6 +93,5 @@
 		for (j = 0; j < (CONSUMERS + PRODUCERS) / 2; j++) {
 			for (k = 0; k < i; k++) {
-				thrd = thread_create(consumer, NULL, TASK,
-				    THREAD_FLAG_NONE, "consumer");
+				thrd = thread_create(consumer, NULL, TASK, 0, "consumer", false);
 				if (thrd)
 					thread_ready(thrd);
@@ -101,6 +100,5 @@
 			}
 			for (k = 0; k < (4 - i); k++) {
-				thrd = thread_create(producer, NULL, TASK,
-				    THREAD_FLAG_NONE, "producer");
+				thrd = thread_create(producer, NULL, TASK, 0, "producer", false);
 				if (thrd)
 					thread_ready(thrd);
Index: kernel/test/synch/semaphore2.c
===================================================================
--- kernel/test/synch/semaphore2.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ kernel/test/synch/semaphore2.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -93,6 +93,5 @@
 	TPRINTF("Creating %" PRIu32 " consumers\n", k);
 	for (i = 0; i < k; i++) {
-		thrd = thread_create(consumer, NULL, TASK,
-		    THREAD_FLAG_NONE, "consumer");
+		thrd = thread_create(consumer, NULL, TASK, 0, "consumer", false);
 		if (thrd)
 			thread_ready(thrd);
Index: kernel/test/thread/thread1.c
===================================================================
--- kernel/test/thread/thread1.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ kernel/test/thread/thread1.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -63,6 +63,5 @@
 	for (i = 0; i < THREADS; i++) {
 		thread_t *t;
-		if (!(t = thread_create(threadtest, NULL, TASK,
-		    THREAD_FLAG_NONE, "threadtest"))) {
+		if (!(t = thread_create(threadtest, NULL, TASK, 0, "threadtest", false))) {
 			TPRINTF("Could not create thread %d\n", i);
 			break;
Index: tools/autotool.py
===================================================================
--- tools/autotool.py	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ tools/autotool.py	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -720,4 +720,10 @@
 			check_binutils(None, binutils_prefix, common, PACKAGE_BINUTILS)
 		
+		if (config['COMPILER'] == "suncc"):
+			common['CC'] = "suncc"
+			check_app([common['CC'], "-V"], "Sun Studio Compiler", "support is experimental")
+			check_gcc(None, "", common, PACKAGE_GCC)
+			check_binutils(None, binutils_prefix, common, PACKAGE_BINUTILS)
+		
 		if (config['COMPILER'] == "clang"):
 			common['CC'] = "clang"
Index: tools/toolchain.sh
===================================================================
--- tools/toolchain.sh	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ tools/toolchain.sh	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -55,5 +55,5 @@
 BINUTILS_VERSION="2.22"
 BINUTILS_RELEASE=""
-GCC_VERSION="4.7.1"
+GCC_VERSION="4.7.0"
 GDB_VERSION="7.4"
 
@@ -149,6 +149,5 @@
 	echo " sparc64    SPARC V9"
 	echo " all        build all targets"
-	echo " parallel   same as 'all', but all in parallel"
-	echo " 2-way      same as 'all', but 2-way parallel"
+	echo " parallel   same as 'all', but in parallel"
 	echo
 	echo "The toolchain will be installed to the directory specified by"
@@ -274,5 +273,5 @@
 	
 	download_fetch "${BINUTILS_SOURCE}" "${BINUTILS}" "ee0f10756c84979622b992a4a61ea3f5"
-	download_fetch "${GCC_SOURCE}" "${GCC}" "933e6f15f51c031060af64a9e14149ff"
+	download_fetch "${GCC_SOURCE}" "${GCC}" "2a0f1d99fda235c29d40b561f81d9a77"
 	download_fetch "${GDB_SOURCE}" "${GDB}" "95a9a8305fed4d30a30a6dc28ff9d060"
 }
@@ -319,5 +318,5 @@
 	
 	change_title "binutils: configure (${PLATFORM})"
-	CFLAGS=-Wno-error ./configure "--target=${TARGET}" "--prefix=${PREFIX}" "--program-prefix=${TARGET}-" --disable-nls --disable-werror
+	CFLAGS=-Wno-error ./configure "--target=${TARGET}" "--prefix=${PREFIX}" "--program-prefix=${TARGET}-" --disable-nls
 	check_error $? "Error configuring binutils."
 	
@@ -331,5 +330,5 @@
 	
 	change_title "GCC: configure (${PLATFORM})"
-	"${GCCDIR}/configure" "--target=${TARGET}" "--prefix=${PREFIX}" "--program-prefix=${TARGET}-" --with-gnu-as --with-gnu-ld --disable-nls --disable-threads --enable-languages=c,objc,c++,obj-c++ --disable-multilib --disable-libgcj --without-headers --disable-shared --enable-lto --disable-werror
+	"${GCCDIR}/configure" "--target=${TARGET}" "--prefix=${PREFIX}" "--program-prefix=${TARGET}-" --with-gnu-as --with-gnu-ld --disable-nls --disable-threads --enable-languages=c,objc,c++,obj-c++ --disable-multilib --disable-libgcj --without-headers --disable-shared --enable-lto
 	check_error $? "Error configuring GCC."
 	
@@ -432,26 +431,4 @@
 		wait
 		;;
-	"2-way")
-		prepare
-		build_target "amd64" "amd64-linux-gnu" &
-		build_target "arm32" "arm-linux-gnueabi" &
-		wait
-		
-		build_target "ia32" "i686-pc-linux-gnu" &
-		build_target "ia64" "ia64-pc-linux-gnu" &
-		wait
-		
-		build_target "mips32" "mipsel-linux-gnu" &
-		build_target "mips32eb" "mips-linux-gnu" &
-		wait
-		
-		build_target "mips64" "mips64el-linux-gnu" &
-		build_target "ppc32" "ppc-linux-gnu" &
-		wait
-		
-		build_target "ppc64" "ppc64-linux-gnu" &
-		build_target "sparc64" "sparc64-linux-gnu" &
-		wait
-		;;
 	*)
 		show_usage
Index: uspace/Makefile
===================================================================
--- uspace/Makefile	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ uspace/Makefile	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -138,9 +138,4 @@
 endif
 
-ifeq ($(CONFIG_MSIM),y)
-DIRS += \
-	app/msim
-endif
-
 ## Platform-specific hardware support
 #
Index: uspace/Makefile.common
===================================================================
--- uspace/Makefile.common	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ uspace/Makefile.common	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -206,4 +206,5 @@
 	GCC_CFLAGS += -g
 	ICC_CFLAGS += -g
+	SUNCC_CFLAGS += -g
 	CLANG_CFLAGS += -g
 endif
Index: uspace/app/devctl/devctl.c
===================================================================
--- uspace/app/devctl/devctl.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ uspace/app/devctl/devctl.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -44,9 +44,7 @@
 #define MAX_NAME_LENGTH 1024
 
-char name[MAX_NAME_LENGTH];
-char drv_name[MAX_NAME_LENGTH];
-
 static int fun_subtree_print(devman_handle_t funh, int lvl)
 {
+	char name[MAX_NAME_LENGTH];
 	devman_handle_t devh;
 	devman_handle_t *cfuns;
@@ -59,18 +57,13 @@
 
 	rc = devman_fun_get_name(funh, name, MAX_NAME_LENGTH);
-	if (rc != EOK)
-		return ELIMIT;
+	if (rc != EOK) {
+		str_cpy(name, MAX_NAME_LENGTH, "unknown");
+		return ENOMEM;
+	}
 
 	if (name[0] == '\0')
 		str_cpy(name, MAX_NAME_LENGTH, "/");
 
-	rc = devman_fun_get_driver_name(funh, drv_name, MAX_NAME_LENGTH);
-	if (rc != EOK && rc != EINVAL)
-		return ELIMIT;
-
-	if (rc == EINVAL)
-		printf("%s\n", name);
-	else
-		printf("%s : %s\n", name, drv_name);
+	printf("%s (%" PRIun ")\n", name, funh);
 
 	rc = devman_fun_get_child(funh, &devh);
Index: uspace/app/killall/killall.c
===================================================================
--- uspace/app/killall/killall.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ uspace/app/killall/killall.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -36,5 +36,4 @@
 #include <errno.h>
 #include <stdio.h>
-#include <unistd.h>
 #include <task.h>
 #include <stats.h>
Index: uspace/app/loc/loc.c
===================================================================
--- uspace/app/loc/loc.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ uspace/app/loc/loc.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -48,9 +48,8 @@
 	size_t svc_cnt;
 	char *svc_name;
-	char *server_name;
 	int rc;
 	size_t j;
 
-	printf("%s:\n", cat_name);
+	printf("%s (%" PRIun "):\n", cat_name, cat_id);
 
 	rc = loc_category_get_svcs(cat_id, &svc_ids, &svc_cnt);
@@ -68,20 +67,6 @@
 			continue;
 		}
-
-		rc = loc_service_get_server_name(svc_ids[j], &server_name);
-		if (rc != EOK && rc != EINVAL) {
-			free(svc_name);
-			printf(NAME ": Unknown service name (SID %"
-			    PRIun ").\n", svc_ids[j]);
-			continue;
-		}
-
-		if (rc == EOK)
-			printf("\t%s : %s\n", svc_name, server_name);
-		else
-			printf("\t%s\n", svc_name);
-	
+		printf("\t%s (%" PRIun ")\n", svc_name, svc_ids[j]);
 		free(svc_name);
-		free(server_name);
 	}
 
Index: uspace/app/nettest1/nettest1.c
===================================================================
--- uspace/app/nettest1/nettest1.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ uspace/app/nettest1/nettest1.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -40,5 +40,4 @@
 #include <malloc.h>
 #include <stdio.h>
-#include <unistd.h>
 #include <str.h>
 #include <task.h>
Index: uspace/app/nettest2/nettest2.c
===================================================================
--- uspace/app/nettest2/nettest2.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ uspace/app/nettest2/nettest2.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -40,5 +40,4 @@
 #include <malloc.h>
 #include <stdio.h>
-#include <unistd.h>
 #include <str.h>
 #include <task.h>
Index: uspace/app/sbi/src/mytypes.h
===================================================================
--- uspace/app/sbi/src/mytypes.h	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ uspace/app/sbi/src/mytypes.h	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -51,6 +51,4 @@
 /** Error return codes. */
 #include <errno.h>
-/** We need NULL defined. */
-#include <unistd.h>
 #define EOK 0
 
Index: uspace/app/sysinfo/sysinfo.c
===================================================================
--- uspace/app/sysinfo/sysinfo.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ uspace/app/sysinfo/sysinfo.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -36,5 +36,4 @@
 #include <errno.h>
 #include <stdio.h>
-#include <unistd.h>
 #include <sysinfo.h>
 #include <malloc.h>
Index: uspace/app/tester/hw/misc/virtchar1.c
===================================================================
--- uspace/app/tester/hw/misc/virtchar1.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ uspace/app/tester/hw/misc/virtchar1.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -48,7 +48,6 @@
 #include "../../tester.h"
 
-#define DEVICE_PATH_NORMAL  "/loc/devices/\\virt\\null\\a"
-
-#define BUFFER_SIZE  64
+#define DEVICE_PATH_NORMAL "/loc/devices/\\virt\\null\\a"
+#define BUFFER_SIZE 64
 
 static const char *test_virtchar1_internal(const char *path)
@@ -66,5 +65,5 @@
 	
 	TPRINTF("   ...file handle %d\n", fd);
-	
+
 	TPRINTF(" Asking for session...\n");
 	async_sess_t *sess = fd_session(EXCHANGE_SERIALIZE, fd);
@@ -97,9 +96,12 @@
 
 const char *test_virtchar1(void)
-{
-	const char *res = test_virtchar1_internal(DEVICE_PATH_NORMAL);
-	if (res != NULL)
+{;
+	const char *res;
+
+	res = test_virtchar1_internal(DEVICE_PATH_NORMAL);
+	if (res != NULL) {
 		return res;
-	
+	}
+
 	return NULL;
 }
Index: uspace/app/tester/mm/common.c
===================================================================
--- uspace/app/tester/mm/common.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ uspace/app/tester/mm/common.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -342,7 +342,7 @@
 	link_initialize(&area->link);
 	
-	area->addr = as_area_create(AS_AREA_ANY, size,
+	area->addr = as_area_create((void *) -1, size,
 	    AS_AREA_WRITE | AS_AREA_READ);
-	if (area->addr == AS_MAP_FAILED) {
+	if (area->addr == (void *) -1) {
 		free(area);
 		check_consistency("map_area (a)");
Index: uspace/app/tester/mm/mapping1.c
===================================================================
--- uspace/app/tester/mm/mapping1.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ uspace/app/tester/mm/mapping1.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -42,7 +42,7 @@
 	TPRINTF("Creating AS area...\n");
 	
-	void *result = as_area_create(AS_AREA_ANY, size,
+	void *result = as_area_create((void *) -1, size,
 	    AS_AREA_READ | AS_AREA_WRITE);
-	if (result == AS_MAP_FAILED)
+	if (result == (void *) -1)
 		return NULL;
 	
Index: uspace/app/trace/proto.h
===================================================================
--- uspace/app/trace/proto.h	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ uspace/app/trace/proto.h	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -44,10 +44,10 @@
 typedef struct {
 	const char *name;
-	
+
 	int argc;
 	val_type_t arg_type[OPER_MAX_ARGS];
-	
+
 	val_type_t rv_type;
-	
+
 	int respc;
 	val_type_t resp_type[OPER_MAX_ARGS];
@@ -57,5 +57,5 @@
 	/** Protocol name */
 	const char *name;
-	
+
 	/** Maps method number to operation */
 	hash_table_t method_oper;
@@ -65,16 +65,18 @@
 extern hash_table_t srv_proto;
 
-extern void proto_init(void);
-extern void proto_cleanup(void);
+void proto_init(void);
+void proto_cleanup(void);
 
-extern void proto_register(int, proto_t *);
-extern proto_t *proto_get_by_srv(int);
-extern proto_t *proto_new(const char *);
-extern void proto_delete(proto_t *);
-extern void proto_add_oper(proto_t *, int, oper_t *);
-extern oper_t *proto_get_oper(proto_t *, int);
+void proto_register(int srv, proto_t *proto);
+proto_t *proto_get_by_srv(int srv);
+proto_t *proto_new(const char *name);
+void proto_delete(proto_t *proto);
+void proto_add_oper(proto_t *proto, int method, oper_t *oper);
+oper_t *proto_get_oper(proto_t *proto, int method);
 
-extern oper_t *oper_new(const char *, int, val_type_t *, val_type_t, int,
-    val_type_t *);
+oper_t *oper_new(const char *name, int argc, val_type_t *arg_types,
+    val_type_t rv_type, int respc, val_type_t *resp_types);
+
+
 
 #endif
Index: uspace/app/websrv/websrv.c
===================================================================
--- uspace/app/websrv/websrv.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ uspace/app/websrv/websrv.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -36,5 +36,4 @@
 #include <bool.h>
 #include <errno.h>
-#include <assert.h>
 #include <stdio.h>
 #include <sys/types.h>
Index: uspace/drv/bus/isa/isa.c
===================================================================
--- uspace/drv/bus/isa/isa.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ uspace/drv/bus/isa/isa.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -201,8 +201,6 @@
 
 	isa_fun_t *fun = ddf_fun_data_alloc(fnode, sizeof(isa_fun_t));
-	if (fun == NULL) {
-		ddf_fun_destroy(fnode);
+	if (fun == NULL)
 		return NULL;
-	}
 
 	fibril_mutex_initialize(&fun->mutex);
@@ -554,6 +552,6 @@
 
 	isa_fun_t *fun = isa_fun_create(isa, fun_name);
-	free(fun_name);
 	if (fun == NULL) {
+		free(fun_name);
 		return NULL;
 	}
Index: uspace/drv/bus/usb/ehci/res.c
===================================================================
--- uspace/drv/bus/usb/ehci/res.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ uspace/drv/bus/usb/ehci/res.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -109,5 +109,5 @@
 	return EOK;
 }
-
+/*----------------------------------------------------------------------------*/
 /** Calls the PCI driver with a request to enable interrupts
  *
@@ -127,5 +127,5 @@
 	return enabled ? EOK : EIO;
 }
-
+/*----------------------------------------------------------------------------*/
 /** Implements BIOS hands-off routine as described in EHCI spec
  *
Index: uspace/drv/bus/usb/ohci/utils/malloc32.h
===================================================================
--- uspace/drv/bus/usb/ohci/utils/malloc32.h	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ uspace/drv/bus/usb/ohci/utils/malloc32.h	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -37,5 +37,4 @@
 #include <assert.h>
 #include <malloc.h>
-#include <unistd.h>
 #include <errno.h>
 #include <mem.h>
Index: uspace/drv/bus/usb/uhci/res.c
===================================================================
--- uspace/drv/bus/usb/uhci/res.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ uspace/drv/bus/usb/uhci/res.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -86,5 +86,5 @@
 	return EOK;
 }
-
+/*----------------------------------------------------------------------------*/
 /** Call the PCI driver with a request to enable interrupts
  *
@@ -105,5 +105,5 @@
 	return enabled ? EOK : EIO;
 }
-
+/*----------------------------------------------------------------------------*/
 /** Call the PCI driver with a request to clear legacy support register
  *
Index: uspace/drv/bus/usb/uhci/utils/malloc32.h
===================================================================
--- uspace/drv/bus/usb/uhci/utils/malloc32.h	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ uspace/drv/bus/usb/uhci/utils/malloc32.h	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -36,5 +36,4 @@
 
 #include <assert.h>
-#include <unistd.h>
 #include <errno.h>
 #include <malloc.h>
@@ -99,7 +98,7 @@
 static inline void * get_page(void)
 {
-	void *address = as_area_create(AS_AREA_ANY, UHCI_REQUIRED_PAGE_SIZE,
+	void *address = as_area_create((void *) -1, UHCI_REQUIRED_PAGE_SIZE,
 	    AS_AREA_READ | AS_AREA_WRITE);
-	if (address == AS_MAP_FAILED)
+	if (address == (void *) -1)
 		return NULL;
 	
Index: uspace/drv/bus/usb/usbmast/main.c
===================================================================
--- uspace/drv/bus/usb/usbmast/main.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ uspace/drv/bus/usb/usbmast/main.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -302,5 +302,5 @@
 	
 	(void) async_share_out_finalize(callid, &comm_buf);
-	if (comm_buf == AS_MAP_FAILED) {
+	if (comm_buf == (void *) -1) {
 		async_answer_0(callid, EHANGUP);
 		return;
Index: uspace/lib/c/arch/ia64/include/fibril.h
===================================================================
--- uspace/lib/c/arch/ia64/include/fibril.h	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ uspace/lib/c/arch/ia64/include/fibril.h	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -49,6 +49,8 @@
 #define PFM_MASK  (~0x3fffffffff)
 
+#define PSTHREAD_INITIAL_STACK_PAGES_NO  2
+
 /* Stack is divided into two equal parts (for memory stack and register stack). */
-#define FIBRIL_INITIAL_STACK_DIVISION  2
+#define PSTHREAD_INITIAL_STACK_DIVISION  2
 
 #define context_set(c, _pc, stack, size, tls) \
@@ -56,8 +58,8 @@
 		(c)->pc = (uint64_t) _pc; \
 		(c)->bsp = ((uint64_t) stack) + \
-		    size / FIBRIL_INITIAL_STACK_DIVISION; \
+		    size / PSTHREAD_INITIAL_STACK_DIVISION; \
 		(c)->ar_pfs &= PFM_MASK; \
 		(c)->sp = ((uint64_t) stack) + \
-		    ALIGN_UP((size / FIBRIL_INITIAL_STACK_DIVISION), STACK_ALIGNMENT) - \
+		    ALIGN_UP((size / PSTHREAD_INITIAL_STACK_DIVISION), STACK_ALIGNMENT) - \
 		    SP_DELTA; \
 		(c)->tp = (uint64_t) tls; \
Index: uspace/lib/c/arch/ia64/include/thread.h
===================================================================
--- uspace/lib/c/arch/ia64/include/thread.h	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ uspace/lib/c/arch/ia64/include/thread.h	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libcia64
+/** @addtogroup libcia64	
  * @{
  */
@@ -36,4 +36,6 @@
 #define LIBC_ia64_THREAD_H_
 
+#define THREAD_INITIAL_STACK_PAGES_NO 2
+
 #endif
 
Index: uspace/lib/c/generic/as.c
===================================================================
--- uspace/lib/c/generic/as.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ uspace/lib/c/generic/as.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -46,11 +46,11 @@
  *
  * @param base  Starting virtual address of the area.
- *              If set to AS_AREA_ANY ((void *) -1),
- *              the kernel finds a mappable area.
+ *              If set to (void *) -1, the kernel finds
+ *              a mappable area.
  * @param size  Size of the area.
  * @param flags Flags describing type of the area.
  *
  * @return Starting virtual address of the created area on success.
- * @return AS_MAP_FAILED ((void *) -1) otherwise.
+ * @return (void *) -1 otherwise.
  *
  */
Index: uspace/lib/c/generic/async.c
===================================================================
--- uspace/lib/c/generic/async.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ uspace/lib/c/generic/async.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -1388,10 +1388,8 @@
 
 	futex_down(&async_futex);
-	if (msg->done) {
+	if (msg->done)
 		amsg_destroy(msg);
-	} else {
-		msg->dataptr = NULL;
+	else 
 		msg->forget = true;
-	}
 	futex_up(&async_futex);
 }
Index: uspace/lib/c/generic/devman.c
===================================================================
--- uspace/lib/c/generic/devman.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ uspace/lib/c/generic/devman.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -430,7 +430,6 @@
 	async_wait_for(req, &retval);
 	
-	if (retval != EOK) {
-		return retval;
-	}
+	if (retval != EOK)
+		return retval;
 	
 	act_size = IPC_GET_ARG2(dreply);
@@ -450,10 +449,4 @@
 {
 	return devman_get_str_internal(DEVMAN_FUN_GET_NAME, handle, buf,
-	    buf_size);
-}
-
-int devman_fun_get_driver_name(devman_handle_t handle, char *buf, size_t buf_size)
-{
-	return devman_get_str_internal(DEVMAN_FUN_GET_DRIVER_NAME, handle, buf,
 	    buf_size);
 }
Index: uspace/lib/c/generic/elf/elf_load.c
===================================================================
--- uspace/lib/c/generic/elf/elf_load.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ uspace/lib/c/generic/elf/elf_load.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -366,5 +366,5 @@
 	a = as_area_create((uint8_t *) base + bias, mem_sz,
 	    AS_AREA_READ | AS_AREA_WRITE | AS_AREA_CACHEABLE);
-	if (a == AS_MAP_FAILED) {
+	if (a == (void *) -1) {
 		DPRINTF("memory mapping failed (0x%x, %d)\n",
 		    base + bias, mem_sz);
Index: uspace/lib/c/generic/fibril.c
===================================================================
--- uspace/lib/c/generic/fibril.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ uspace/lib/c/generic/fibril.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -286,20 +286,4 @@
 }
 
-/** Delete a fibril that has never run.
- *
- * Free resources of a fibril that has been created with fibril_create()
- * but never readied using fibril_add_ready().
- *
- * @param fid Pointer to the fibril structure of the fibril to be
- *            added.
- */
-void fibril_destroy(fid_t fid)
-{
-	fibril_t *fibril = (fibril_t *) fid;
-	
-	free(fibril->stack);
-	fibril_teardown(fibril);
-}
-
 /** Add a fibril to the ready list.
  *
Index: uspace/lib/c/generic/inet.c
===================================================================
--- uspace/lib/c/generic/inet.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ uspace/lib/c/generic/inet.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -44,25 +44,29 @@
 {
 	async_exch_t *exch = async_exchange_begin(inet_sess);
-	
+
 	ipc_call_t answer;
 	aid_t req = async_send_0(exch, INET_CALLBACK_CREATE, &answer);
 	int rc = async_connect_to_me(exch, 0, 0, 0, inet_cb_conn, NULL);
 	async_exchange_end(exch);
-	
+
 	if (rc != EOK)
 		return rc;
-	
+
 	sysarg_t retval;
 	async_wait_for(req, &retval);
-	
-	return retval;
+	if (retval != EOK)
+		return retval;
+
+	return EOK;
 }
 
 static int inet_set_proto(uint8_t protocol)
 {
+	int rc;
+
 	async_exch_t *exch = async_exchange_begin(inet_sess);
-	int rc = async_req_1_0(exch, INET_SET_PROTO, protocol);
+	rc = async_req_1_0(exch, INET_SET_PROTO, protocol);
 	async_exchange_end(exch);
-	
+
 	return rc;
 }
@@ -76,15 +80,15 @@
 	assert(inet_ev_ops == NULL);
 	assert(inet_protocol == 0);
-	
+
 	rc = loc_service_get_id(SERVICE_NAME_INET, &inet_svc,
 	    IPC_FLAG_BLOCKING);
 	if (rc != EOK)
 		return ENOENT;
-	
+
 	inet_sess = loc_service_connect(EXCHANGE_SERIALIZE, inet_svc,
 	    IPC_FLAG_BLOCKING);
 	if (inet_sess == NULL)
 		return ENOENT;
-	
+
 	if (inet_set_proto(protocol) != EOK) {
 		async_hangup(inet_sess);
@@ -92,5 +96,5 @@
 		return EIO;
 	}
-	
+
 	if (inet_callback_create() != EOK) {
 		async_hangup(inet_sess);
@@ -98,5 +102,5 @@
 		return EIO;
 	}
-	
+
 	inet_protocol = protocol;
 	inet_ev_ops = ev_ops;
Index: uspace/lib/c/generic/iplink.c
===================================================================
--- uspace/lib/c/generic/iplink.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ uspace/lib/c/generic/iplink.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -49,26 +49,29 @@
     iplink_t **riplink)
 {
-	iplink_t *iplink = calloc(1, sizeof(iplink_t));
+	iplink_t *iplink = NULL;
+	int rc;
+
+	iplink = calloc(1, sizeof(iplink_t));
 	if (iplink == NULL)
 		return ENOMEM;
-	
+
 	iplink->sess = sess;
 	iplink->ev_ops = ev_ops;
-	
+
 	async_exch_t *exch = async_exchange_begin(sess);
-	
-	int rc = async_connect_to_me(exch, 0, 0, 0, iplink_cb_conn, iplink);
+
+	rc = async_connect_to_me(exch, 0, 0, 0, iplink_cb_conn, iplink);
 	async_exchange_end(exch);
-	
+
 	if (rc != EOK)
 		goto error;
-	
+
 	*riplink = iplink;
 	return EOK;
-	
+
 error:
 	if (iplink != NULL)
 		free(iplink);
-	
+
 	return rc;
 }
Index: uspace/lib/c/generic/loc.c
===================================================================
--- uspace/lib/c/generic/loc.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ uspace/lib/c/generic/loc.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -450,18 +450,4 @@
 }
 
-/** Get service server name.
- *
- * Provided ID of a service, return the name of its server.
- *
- * @param svc_id	Service ID
- * @param name		Place to store pointer to new string. Caller should
- *			free it using free().
- * @return		EOK on success or negative error code
- */
-int loc_service_get_server_name(service_id_t svc_id, char **name)
-{
-	return loc_get_name_internal(LOC_SERVICE_GET_SERVER_NAME, svc_id, name);
-}
-
 int loc_namespace_get_id(const char *name, service_id_t *handle,
     unsigned int flags)
